from django.shortcuts import render
from rest_framework.views import APIView
from rest_framework.response import Response
from rest_framework.exceptions import AuthenticationFailed
from app.serializers import UserSerialzier
from app.models import User


# Create your views here.

class Dataview(APIView):

    def get(self, request):
        users = User.objects.all()
        res = UserSerialzier(users, many=True)

        return Response(res.data)

    def post(self, request):
        # < QueryDict: {'age': ['60'], 'brief': ['我什么简介要你管'], 'name': ['老王']} >
        # 如果需要转换数据，改为值不是列表，就是普通数据
        # dic = {}
        # for temp in request.data.items():
        #     dic[temp[0]] = temp[1]
        #
        # data = UserSerialzier(data=dic)

        data = UserSerialzier(data=request.data)
        if data.is_valid():
            data.save()
            return Response(data.data)
        else:
            return Response(data.errors)


class DataEditview(APIView):

    def put(self, request, id):
        user_obj = User.objects.filter(id=id).first()

        data = UserSerialzier(user_obj, data=request.data, partial=True)
        if data.is_valid():
            data.save()
            return Response(data.data)
        else:
            return Response(data.errors)

    def delete(self, request, id):
        user_obj = User.objects.filter(id=id).first()
        if not user_obj:
            return Response('不存在该用户')
        else:
            User.objects.filter(id=id).delete()
            return Response('删除成功')
